/* numrules.c */
/* ITOGAWA's Slitherlink Solver */

/*
 ˴طؿޤäƤ롣
*/

#include "slink.h"

void mark0(geometry i, geometry j)
{
    direction d;

    for (d=0; d <= 7; d+=2)
	recolor(the->color DIRECTION(d), the->color HERE);
}

void mark3(geometry i, geometry j)
{
    direction d;
    geometry p, q;

    for (d=0; d <= 7; d++)
	if (!(d & 1)) /* Ĳ */
	{
	    if (sides DIRECTION(d) == 3)
	    {
		recolor(the->color DIRECTION(d  ), -(the->color HERE));
		recolor(the->color DIRECTION(d+4), -(the->color HERE));
		recolor(the->color DIRECTION(d+2),   the->color DIRECTION(d+1) );
		recolor(the->color DIRECTION(d+6), -(the->color DIRECTION(d+2)));
		recolor(the->color DIRECTION(d+7),   the->color DIRECTION(d+6) );
		/* ¤ϡɬϤʤ */
	    }
       	    if ((sides DIRECTION(d+1) == 3) && (sides DIRECTION(d+3) == 3))
	    {
		recolor(the->color OVER_DIRECTION(d+2), the->color HERE);
	    }    
	}
    	else /* Ф */
	{
	    p = i+dy[d];
	    q = j+dx[d];
	    while (sides[p][q] == 2)
	    {
		p += dy[d];
		q += dx[d];
	    }
	    if (sides[p][q] == 3)
	    {
		recolor(the->color DIRECTION(d+7), -(the->color DIRECTION(d+1)));
	    }
	}
}

void chk_corner(geometry i, geometry j)
{
    direction d;

    for (d=0; d <= 7; d+=2)
    {
	if (the->color DIRECTION(d) == -(the->color HERE))
	{
	    if (the->color DIRECTION(d+2) == -(the->color HERE))
		recolor(the->color DIRECTION(d+1), -(the->color HERE));
	    if (the->color DIRECTION(d+2) == -(the->color DIRECTION(d+1)))
		recolor(the->color DIRECTION(d+2),   the->color HERE );
	}
    }
}

void chk_around(geometry i, geometry j)
{
    if ((the->color DIRECTION(0) == the->color DIRECTION(2)) &&
	(the->color DIRECTION(2) == the->color DIRECTION(4)) &&
	(the->color DIRECTION(4) == the->color DIRECTION(6)))
	recolor(the->color HERE, the->color DIRECTION(0));
}

void chk1(geometry i, geometry j)
{
    direction d;

    for (d=0; d <= 7; d+=2)
    {
	if (the->color DIRECTION(d) == -(the->color HERE))
	{
	    recolor(the->color DIRECTION(d+2), the->color HERE);
	    recolor(the->color DIRECTION(d+4), the->color HERE);
	    recolor(the->color DIRECTION(d+6), the->color HERE);
	}

	if (the->color DIRECTION(d) == the->color DIRECTION(d+2))
	{
	    recolor(the->color DIRECTION(d  ),   the->color HERE);
	    recolor(the->color DIRECTION(d+6), -(the->color DIRECTION(d+4)));
	}
	else if (the->color DIRECTION(d) == -(the->color DIRECTION(d+2)))
	{
	    recolor(the->color DIRECTION(d+4), the->color HERE);
	    recolor(the->color DIRECTION(d+6), the->color HERE);
	}

	if (the->color DIRECTION(d) == the->color DIRECTION(d+4))
	{
	    recolor(the->color DIRECTION(d  ),   the->color HERE);
	    recolor(the->color DIRECTION(d+6), -(the->color DIRECTION(d+2)));
	}
	else if (the->color DIRECTION(d) == -(the->color DIRECTION(d+4)))
	{
	    recolor(the->color DIRECTION(d+2), the->color HERE);
	    recolor(the->color DIRECTION(d+6), the->color HERE);
	}
	if (sides DIRECTION(d) == 3)
	{
	    if (the->color DIRECTION(d+1) == the->color DIRECTION(d+2))
	    {
		recolor(the->color DIRECTION(d+4),   the->color HERE);
		recolor(the->color DIRECTION(d+6),   the->color HERE);
		recolor(the->color DIRECTION(d+1), -(the->color DIRECTION(d)));
	    }
	    if (the->color DIRECTION(d+6) == the->color DIRECTION(d+7))
	    {
		recolor(the->color DIRECTION(d+2),   the->color HERE);
		recolor(the->color DIRECTION(d+4),   the->color HERE);
		recolor(the->color DIRECTION(d+7), -(the->color DIRECTION(d)));
	    }
	}
	if ((sides DIRECTION(d+1) == 1) &&
	    (the->color KNIGHT_DIRECTION(d+1) == the->color DIRECTION(d+1)) &&
	    (the->color KNIGHT_DIRECTION(d  ) == the->color DIRECTION(d+1)))
	{
	    recolor(the->color DIRECTION(d+4), the->color HERE);
	    recolor(the->color DIRECTION(d+6), the->color HERE);
	}
    }
}

void chk2(geometry i, geometry j)
{
    direction d;

    for (d=0; d <= 7; d+=2)
    {
	if (the->color DIRECTION(d) == the->color HERE)
	{
	    if (the->color DIRECTION(d+1) == -(the->color HERE) &&
		the->color DIRECTION(d+3) ==   the->color HERE)
		recolor(the->color DIRECTION(d+6), -(the->color HERE));
	    if (the->color DIRECTION(d+7) == -(the->color HERE) &&
		the->color DIRECTION(d+5) ==   the->color HERE)
		recolor(the->color DIRECTION(d+2), -(the->color HERE));
	    if (the->color DIRECTION(d+3) == -(the->color DIRECTION(d+2)) ||
		the->color DIRECTION(d+3) == -(the->color DIRECTION(d+4)))
		recolor(the->color DIRECTION(d+6), -(the->color HERE));
	    if (the->color DIRECTION(d+5) == -(the->color DIRECTION(d+6)) ||
		the->color DIRECTION(d+5) == -(the->color DIRECTION(d+4)))
		recolor(the->color DIRECTION(d+2), -(the->color HERE));
	    if (sides DIRECTION(d+3) == 3)
	    {
		recolor(the->color DIRECTION(d+2), -(the->color DIRECTION(d+4)));
		recolor(the->color DIRECTION(d+6), -(the->color DIRECTION(d  )));
	    }
	    if (sides DIRECTION(d+5) == 3)
	    {
		recolor(the->color DIRECTION(d+2), -(the->color DIRECTION(d  )));
		recolor(the->color DIRECTION(d+6), -(the->color DIRECTION(d+4)));
	    }
	}

	if (the->color DIRECTION(d) == the->color DIRECTION(d+2))
	{
	    recolor(the->color DIRECTION(d+4), -(the->color DIRECTION(d)));
	    recolor(the->color DIRECTION(d+6), -(the->color DIRECTION(d)));
	}
	else if (the->color DIRECTION(d) == -(the->color DIRECTION(d+2)))
	    recolor(the->color DIRECTION(d+4), -(the->color DIRECTION(d+6)));

	if (the->color DIRECTION(d) == the->color DIRECTION(d+4))
	{
	    recolor(the->color DIRECTION(d+2), -(the->color DIRECTION(d)));
	    recolor(the->color DIRECTION(d+6), -(the->color DIRECTION(d)));
	}
	else if (the->color DIRECTION(d) == -(the->color DIRECTION(d+4)))
	    recolor(the->color DIRECTION(d+2), -(the->color DIRECTION(d+6)));
	
	if ((sides DIRECTION(d) == 3))
	{
	   if ((the->color DIRECTION(d+2) == -(the->color DIRECTION(d+6))) &&
	       (the->color DIRECTION(d+4) == -(the->color DIRECTION(d  ))))
	   {
	       recolor(the->color OVER_DIRECTION(d), -(the->color DIRECTION(d)));

	       if (the->color DIRECTION(d+2) == the->color DIRECTION(d))
		   recolor(the->color DIRECTION(d+7), -(the->color DIRECTION(d)));
	       if (the->color DIRECTION(d+6) == the->color DIRECTION(d))
		   recolor(the->color DIRECTION(d+1), -(the->color DIRECTION(d)));
	   }
	   if (the->color OVER_DIRECTION(d) == -(the->color DIRECTION(d)))
	   {
	       if (the->color DIRECTION(d+1) == -(the->color DIRECTION(d)) &&
		   sides DIRECTION(d+5) == 3)
		   recolor(the->color DIRECTION(d+4), -(the->color DIRECTION(d+6)));
	       if (the->color DIRECTION(d+7) == -(the->color DIRECTION(d)) &&
		   sides DIRECTION(d+3) == 3)
		   recolor(the->color DIRECTION(d+4), -(the->color DIRECTION(d+2)));
	   }
	   if ((the->color DIRECTION(d+6) ==   the->color HERE) &&
	       (the->color DIRECTION(d+7) == -(the->color DIRECTION(d+6))))
	   {
	       recolor(the->color DIRECTION(d+4), -(the->color HERE));
	       recolor(the->color DIRECTION(d+1),   the->color DIRECTION(d+2));
	   }
	   if ((the->color DIRECTION(d+2) ==   the->color HERE) &&
	       (the->color DIRECTION(d+1) == -(the->color DIRECTION(d+2))))
	   {
	       recolor(the->color DIRECTION(d+4), -(the->color HERE));
	       recolor(the->color DIRECTION(d+6),   the->color DIRECTION(d+7));
	   }
	}
    }
}

void chk3(geometry i, geometry j)
{
    direction d, k;
    for (d=0; d <= 7; d+=2)
    {
	if (the->color DIRECTION(d) == the->color HERE)
	    for (k = 2; k <= 6; k++)
		recolor(the->color DIRECTION(d+k), -(the->color HERE));

	if (the->color DIRECTION(d) == the->color DIRECTION(d+2))
	{
	    recolor(the->color DIRECTION(d  ), -(the->color HERE));
	    recolor(the->color DIRECTION(d+1), -(the->color HERE));
	    recolor(the->color DIRECTION(d+6), -(the->color DIRECTION(d+4)));
	}
	else if (the->color DIRECTION(d) == -(the->color DIRECTION(d+2)))
	{
	    recolor(the->color DIRECTION(d+4), -(the->color HERE));
	    recolor(the->color DIRECTION(d+5), -(the->color HERE));
	    recolor(the->color DIRECTION(d+6), -(the->color HERE));
	}

        if (the->color DIRECTION(d) == the->color DIRECTION(d+4))
	{
	    recolor(the->color DIRECTION(d  ), -(the->color HERE));
	    recolor(the->color DIRECTION(d+6), -(the->color DIRECTION(d+2)));
	}
        else if (the->color DIRECTION(d) == -(the->color DIRECTION(d+4)))
	{
	    recolor(the->color DIRECTION(d+2), -(the->color HERE));
	    recolor(the->color DIRECTION(d+6), -(the->color HERE));
	}

        if (the->color DIRECTION(d) == -(the->color DIRECTION(d+1)))
	{
	    recolor(the->color DIRECTION(d+2),   the->color DIRECTION(d+1));
	    recolor(the->color DIRECTION(d+4), -(the->color HERE));
	    recolor(the->color DIRECTION(d+5), -(the->color HERE));
	    recolor(the->color DIRECTION(d+6), -(the->color HERE));
	}
        if (the->color DIRECTION(d) == -(the->color DIRECTION(d+7)))
	{
	    recolor(the->color DIRECTION(d+6),   the->color DIRECTION(d+7));
	    recolor(the->color DIRECTION(d+2), -(the->color HERE));
	    recolor(the->color DIRECTION(d+3), -(the->color HERE));
	    recolor(the->color DIRECTION(d+4), -(the->color HERE));
	}
        if (the->color DIRECTION(d) == -(the->color DIRECTION(d+3)))
	    recolor(the->color DIRECTION(d+6), -(the->color HERE));
        if (the->color DIRECTION(d) == -(the->color DIRECTION(d+5)))
	    recolor(the->color DIRECTION(d+2), -(the->color HERE));

        if (the->color DIRECTION(d  ) == -(the->color OVER_DIRECTION(d)) &&
	    the->color DIRECTION(d+4) == -(the->color HERE) &&
	    abs(the->color HERE) != abs(the->color DIRECTION(d)))
	{
	    if (the->color DIRECTION(d  ) == -(the->color DIRECTION(d+1)) &&
		the->color DIRECTION(d+6) == -(the->color HERE))
		recolor(the->color DIRECTION(d+7), the->color DIRECTION(d));
	    if (the->color DIRECTION(d  ) == -(the->color DIRECTION(d+7)) &&
		the->color DIRECTION(d+2) == -(the->color HERE))
		recolor(the->color DIRECTION(d+1), the->color DIRECTION(d));
	}
        if (the->color DIRECTION(d+1) == the->color OVER_DIRECTION(d) &&
	    the->color DIRECTION(d+7) == the->color OVER_DIRECTION(d))
	    recolor(the->color DIRECTION(d), the->color OVER_DIRECTION(d));
    }
}

